unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, db, sqldb, sqldblib, IBConnection, Forms, Controls,
  Graphics, Dialogs, StdCtrls, DBGrids, dynlibs;

const
  keyName = 'Zero';
  keyZero :array [0..31] of byte  = ($30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30);

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    SQLConnector1: TSQLConnector;
    SQLDBLibraryLoader1: TSQLDBLibraryLoader;
    SQLQuery1: TSQLQuery;
    SQLTransaction1: TSQLTransaction;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    MyLibC:TLibHandle;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
type
  //extern "C" int fbcrypt_init(const char* clientPathName);
  Tfbcrypt_init_Func=function (aStr: string):Integer; StdCall;

  //extern "C" int fbcrypt_key(const char* name, const unsigned char* data, unsigned dl);
  Tfbcrypt_key_Func = function (pszKeyName:Pointer;pKeyValue:Pointer;iKeyLength:Cardinal):Integer; StdCall;

  //extern "C" int fbcrypt_callback(void* provider);
  Tfbcrypt_callback_Func = function(provider:Pointer):Integer; StdCall;
var
  ClintLib   :String;
  fnCrIni    :Tfbcrypt_init_Func;
  fnSetKey   :Tfbcrypt_key_Func;
  fnCrCB     :Tfbcrypt_callback_Func;
  iFnResult  :Integer;
begin
  ClintLib := SQLDBLibraryLoader1.LibraryName;
  //SQLDBLibraryLoader1.ConnectionType:='Firebird';
  // Note: .ConnectionType resets the LibraryName, so set LibraryName after
  // setting ConnectionType!!
  //SQLDBLibraryLoader1.LibraryName := '/opt/firebird/lib/libfbclient.so.3.0.8';
  //SQLDBLibraryLoader1.Enabled := true;
  //SQLDBLibraryLoader1.LoadLibrary;


  MyLibC := LoadLibrary('/opt/firebird/lib/libfbcrypt.' + SharedSuffix);
  if MyLibC = dynlibs.NilHandle then Exit;

  fnCrIni := Tfbcrypt_init_Func(GetProcedureAddress(MyLibC, 'fbcrypt_init'));
  if fnCrIni = nil then Exit;

  fnSetKey := Tfbcrypt_key_Func(GetProcedureAddress(MyLibC, 'fbcrypt_key'));
  if fnSetKey = nil then Exit;

  fnCrCB := Tfbcrypt_callback_Func(GetProcedureAddress(MyLibC, 'fbcrypt_callback'));
  if fnCrCB = nil then Exit;

  iFnResult:= fnCrIni(ClintLib);

  iFnResult:= fnSetKey(@keyName[1], @keyZero[0], 32);

  iFnResult:= fnCrCB(nil);


  SQLDBLibraryLoader1.Enabled := true;
  SQLDBLibraryLoader1.LoadLibrary;

  SQLConnector1.Open;
  SQLQuery1.Open;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  MyLibC := dynlibs.NilHandle;
end;



procedure TForm1.FormDestroy(Sender: TObject);
begin
  if MyLibC <>  DynLibs.NilHandle then if FreeLibrary(MyLibC) then MyLibC:= DynLibs.NilHandle;  //Unload the lib, if already loaded
end;

end.

